"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ConfigModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigModule = void 0;
const node_crypto_1 = require("node:crypto");
const common_1 = require("@nestjs/common");
const utils_1 = require("./utils");
const config_service_1 = require("./config.service");
let ConfigModule = ConfigModule_1 = class ConfigModule {
    static forRoot(providers) {
        return {
            global: true,
            module: ConfigModule_1,
            providers: [
                {
                    provide: 'GLOBAL_CONFIG_MAP',
                    useValue: new Map()
                },
                {
                    provide: 'GLOBAL_ENVIRONMENT_VARIABLES',
                    useValue: (0, utils_1.getEnvironmentVariables)()
                },
                config_service_1.ConfigService,
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    inject: [config_service_1.ConfigService],
                    useFactory: (configService) => {
                        configService.add(providers || []).validate(providers || []);
                    }
                }
            ],
            exports: [config_service_1.ConfigService]
        };
    }
    static forFeature(providers) {
        return {
            module: ConfigModule_1,
            providers: [
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    useFactory: (configService) => {
                        if (!configService) {
                            throw new Error('Failed to find ConfigService. Have you registered ConfigModule.forRoot()?');
                        }
                        return configService.add(providers).validate(providers);
                    },
                    inject: [
                        {
                            optional: true,
                            token: config_service_1.ConfigService
                        }
                    ]
                }
            ]
        };
    }
    static forTest(provider, overrides) {
        return {
            global: true,
            module: ConfigModule_1,
            providers: [
                {
                    provide: 'GLOBAL_CONFIG_MAP',
                    useValue: new Map()
                },
                {
                    provide: 'GLOBAL_ENVIRONMENT_VARIABLES',
                    useValue: (0, utils_1.getEnvironmentVariables)()
                },
                {
                    provide: 'CONFIG_PROVIDERS',
                    useValue: [provider]
                },
                config_service_1.ConfigService,
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    inject: [config_service_1.ConfigService],
                    useFactory: (configService) => {
                        configService.add([provider]);
                        configService.override(provider, overrides);
                        configService.validate([provider]);
                    }
                }
            ],
            exports: [config_service_1.ConfigService]
        };
    }
};
exports.ConfigModule = ConfigModule;
exports.ConfigModule = ConfigModule = ConfigModule_1 = __decorate([
    (0, common_1.Module)({})
], ConfigModule);
//# sourceMappingURL=config.module.js.map