import { Class, ConfigMap } from './types';
type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends ((k: infer T) => void) ? T : never;
type Flatten<T> = T extends ReadonlyArray<infer Item> ? Item extends Class ? InstanceType<Item> : Item : T;
export declare class ConfigService {
    private readonly configs;
    private readonly envs;
    private readonly logger;
    constructor(configs: ConfigMap, envs: Record<string, string>);
    add(providers: Array<Class>): this;
    get<Config>(provider: Class<Config>): Config;
    value<Config, Key extends keyof Config>(provider: Class<Config>, key: Key, defaultValue?: Config[Key]): Config[Key];
    values<Providers extends Array<Class>>(...providers: Providers): UnionToIntersection<Flatten<Providers>>;
    override<Config>(provider: Class<Config>, overrides?: Partial<Config>): Config;
    validate<Config>(providers: Array<Class<Config>>): void;
    getConfigs(): ConfigMap;
}
export {};
